// http://we.easyelectronics.ru/Soft/asimmetrichnoe-shifrovanie-rsa-eto-ochen-prosto.html
#include "rsa.h"
#include <math.h>

huge_t modexp(huge_t a, huge_t b, huge_t n) 
{
  huge_t y=1;
//  printf("modexp=%llu %llu %llu",a,b,n);

  /*  Compute pow(a, b) % n using the binary square and multiply method. */
  while (b != 0) 
  {
    /*  For each 1 in b, accumulate y. */
    if (b & 1)
    {
      y = (y * a) % n;
    }

    /* Square a for each bit in b. */
    a = (a * a) % n;

    /*  Prepare for the next bit in b. */
    b = b >> 1;
  }
//  printf(" %llu\n",y);
  return y;
}

//GCD(e, (p-1)*(q-1))
huge_t GCD(huge_t x,huge_t y)
{
	while (1)
	{
		if (y == 0) return x;
		x = x % y;
		if (x == 0) return y;
		y = y % x;
	}
}


huge_t modinv(huge_t a,huge_t m)
{
 signed long long b = m;
 signed long long c = a;
 signed long long i = 0;
 signed long long j = 1;

	long long x,y;

	while (c != 0)
	{
		x = b / c;
		y = b % c;
		b = c;
		c = y;
		y = j;
		j = i - j * x;
		i = y;
	}

	if (i < 0) i += m;

	return i;
}

int ToSimple(int i) {
int j = 3;
 i|=1;
 while(j*j <= i)
 {
	while(!(i % j))
    {
	i+=2;
	j =3;
    }
	j+=2;
 }
 return i;
}

